#include <hmg.ch>
#include "hmg_hpdf.ch"

PROCEDURE Main()
   
   cAFCPsPFN := "HPDF_FsCPs.pdf"   // HPDF_Fonts & CodePages PDF File Name
   
   DEFINE WINDOW frmAnExtOfr ;
      AT 0, 0 ;
      WIDTH 300 ;
      HEIGHT 300 ;
      MAIN ;
      TITLE 'HMG-HPDF Fonts'
      
      ON KEY ESCAPE ACTION ThisWindow.Release
      
      DEFINE MAIN MENU
      
			POPUP 'Fonts'
         
            ITEM 'Build'   ACTION BuildPDF( cAFCPsPFN )
    			ITEM 'Display' ACTION Disp_PDF( cAFCPsPFN )
	   		ITEM 'Print'   ACTION PrintPDF( cAFCPsPFN )
            
   		SEPARATOR
         
	   	ITEM 'Exit' ACTION ThisWindow.Release
         
         END POPUP
         
      END MENU      
      
   END WINDOW
   
   CENTER WINDOW   frmAnExtOfr
   ACTIVATE WINDOW frmAnExtOfr

RETURN // HPDF_Fonts.Main()

*.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._
/*

   Display .pdf file without re-build.
   
*/
PROCEDURE Disp_PDF( cPFName )

   IF FILE( cPFName )
      EXECUTE FILE cPFName
   ELSE
      MsgStop( cPFName + " file not found !", "ERROR !" )
   ENDIF      
   
RETURN // Disp_PDF()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

/*

   Print .pdf file without user intervention and Print Dialog of OS (to default printer).
   
   Thanks to Dave (BPD) for hint.
   
*/

PROCEDURE PrintPDF( cPFName )

   IF FILE( cPFName )
      SHELLEXECUTE( 0, "PRINT", cPFName )         
   ELSE
      MsgStop( cPFName + " file not found !", "ERROR !" )
   ENDIF      

RETURN // PrintPDF()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE BuildPDF( ;                     
                   cPdfFName )
                   
   LOCAL lSuccess :=  .F.,;
         nLineNo  :=   0,;
         nItemCo  :=   0,;    // Line count in text array 
         nItemNo  :=   0,;    // Line in text array 
         nLineRow :=  30,;    // 25 + 5 
         nLineCol :=  25,;    // Left marj
         nMaxPRow := 272,;    // 297 - 25  // * 2 ) - 10  
         nMaxPCol := 185,;    // 210 - 25
         nLineSpc :=   5,;    // Line Space  ( NO for "rectangled" text )        
         nPageNo  :=   0,;
         cFCode   :=  '',;     // Format code
         c1FB14Name :=  '',;
         cSamplStr :=  "ABCDEFGHIabcdefghi012345!#$%&+-@?",;
         nLMargin,;
         nTextWidth,;
         oFont,;
         aText 
         
   LOCAL aFB14List := { "Courier",;
                        "Courier-Bold",;
                        "Courier-Oblique",;
                        "Courier-BoldOblique",;
                        "Helvetica",;
                        "Helvetica-Bold",;
                        "Helvetica-Oblique",;
                        "Helvetica-BoldOblique",;
                        "Times-Roman",;
                        "Times-Bold",;
                        "Times-Italic",;
                        "Times-BoldItalic",;
                        "Symbol" }
                        
   LOCAL aTTFFList := { { "Calibri", "Calibri"         },;
                        { "Century", "Century Normal"  },;
                        { "Comic",   "Comic Sans MS"   },;
                        { "Consola", "Consolas"        },; 
                        { "Elephnt", "Elephant"        },;
                        { "Georgia", "Georgia"         },;
                        { "Gothic",  "Franklin Gothic" },;
                        { "Impact",  "Impact Normal"   },;
                        { "LuCon",   "Lucida Console"  },;
                        { "Tahoma",  "Tahoma"          },;
                        { "trebuc",  "Trebuchet"       },;
                        { "Verdana", "Verdana"         } },;
         a1TTFont,;
         c1TTFFName,;
         c1TTFntNam
                        
   LOCAL aCPagList := { { "CP1250", " ( EE )",          ""             } ,;
                        { "CP1251", " ( Cyrlic )",      ""             } ,;
                        { "CP1252", " ( ANSI )",        ""             } ,;
                        { "CP1253", " ( Greek )",       ""             } ,;
                        { "CP1254", " ( Turkish )",     "" } ,;
                        { "CP1255", " ( Hebrew )",      ""             } ,;
                        { "CP1256", " ( Arabic )",      ""             } ,;
                        { "CP1257", " ( BaltRim )",     ""             } ,;
                        { "CP1258", " ( Vietnam )",     ""             } ,;
                        { "KOI8-R", " ( Russian Net )", ""             }  },;
         a1CPCode,;
         c1CPCode,;
         c1CPName,;
         c1CPSmpS 
               
                        
   LOCAL oPDF,;
         oPage,;
         hFont,;
         cTTFFName,;
         cFontName,;
         nFontSize := 14,;    
         nSFResult          // Set Font Result
      
   aCPagList[ 2, 3 ] := HB_MEMOREAD( "CyrilLetters.txt" )
   aCPagList[ 4, 3 ] := HB_MEMOREAD( "GreekLetters.txt" )
         
   SELECT HPDFDOC cPdfFName TO lSuccess papersize HPDF_PAPER_A4 // A4 210 x 297 mm
   
   IF lSuccess
   
      oPDF := _HMG_SYSDATA[ 150, 1 ]
   
      SET HPDFDOC COMPRESS ALL
      
      SET HPDFDOC PAGEMODE TO OUTLINE

      START HPDFDOC
      
         SET HPDFDOC ROOTOUTLINE TITLE "Fonts & CodePages" NAME "HPDF_Fonts" 
         SET HPDFDOC ROOTOUTLINE TITLE "Base 14 Fonts"     NAME "B14Fonts" PARENT "HPDF_Fonts"
         SET HPDFDOC ROOTOUTLINE TITLE "True Type Fonts"   NAME "TTFonts"  PARENT "HPDF_Fonts" 
         
         FOR EACH c1FB14Name IN aFB14List
         
            nLineNo  := 0
            nLineRow := 25
            nLineSpc :=  5
              
            START HPDFPAGE  // Base 14 font samples
            
               SET HPDFDOC PAGEOUTLINE TITLE c1FB14Name PARENT "B14Fonts"
               
               @ nLineRow, nLineCol HPDFPRINT RECTANGLE ;
                 TO nMaxPRow, nMaxPCol
                 
                 cTitle := c1FB14Name
                 
               @ nLineRow, nLineCol HPDFPRINT cTitle TO nLineRow, nMaxPCol ;
                 FONT 'Times-Bold' SIZE 14 CENTER
                 nLineRow += nLineSpc * 2  
                 
               nLineSpc *= 4.5
                  
               FOR EACH a1CPCode IN aCPagList
   
                  c1CPCode := a1CPCode[ 1 ]
                  c1CPName := a1CPCode[ 2 ]
                  c1CPSmpS := a1CPCode[ 3 ]
                  
                  SET HPDFDOC ENCODING TO c1CPCode 
                        
                  nLineRow += nLineSpc
                  
                  @ nLineRow-7, nLineCol + 12 HPDFPRINT c1CPCode + c1CPName   FONT "Helvetica" SIZE 10
                  @ nLineRow,   nLineCol + 12 HPDFPRINT cSamplStr             FONT c1FB14Name SIZE nFontSize
                  @ nLineRow+7, nLineCol + 12 HPDFPRINT c1CPSmpS              FONT c1FB14Name SIZE nFontSize
                        
               NEXT a1CPCode 
               
            END HPDFPAGE // Base 14 font samples                    
            
         NEXT c1FB14Name 
         
         FOR EACH a1TTFont IN aTTFFList // True Type Fonts
            
            c1TTFFName := a1TTFont[ 1 ]
            c1TTFntNam := a1TTFont[ 2 ]

            START HPDFPAGE  // TrueType Fonts samples
            
               oPage := _HMG_SYSDATA[ 150, 7 ]
               cTitle := c1TTFntNam
               nLineNo  := 0
               nLineRow := 25
               nLineSpc :=  5
               
               cTTFFName := "C:\Windows\Fonts\" + c1TTFFName + ".ttf"
               
               SET HPDFDOC PAGEOUTLINE TITLE c1TTFntNam PARENT "TTFonts"
               
               @ nLineRow, nLineCol HPDFPRINT cTitle TO nLineRow, nMaxPCol ;
                 FONT 'Times-Bold' SIZE 14 CENTER
                 nLineRow += nLineSpc * 2  
                 
               @ nLineRow, nLineCol HPDFPRINT RECTANGLE ;
                 TO nMaxPRow, nMaxPCol
                 
               IF HB_FileExists( cTTFFName )
                   
                  cFontName := HPDF_LoadTTFontFromFile( oPDF, cTTFFName, .F. )
            
                  IF !EMPTY( cFontName )
                  
                     nLineSpc *= 4.5
                  
                     FOR EACH a1CPCode IN aCPagList
   
                        c1CPCode := a1CPCode[ 1 ]
                        c1CPName := a1CPCode[ 2 ]
                        c1CPSmpS := a1CPCode[ 3 ]
                     
                        hfont := HPDF_GetFont( oPDF, cFontName, c1CPCode )

                        nSFResult := HPDF_Page_SetFontAndSize( oPage, hfont, nFontSize )
                        
                        IF nSFResult = 0

                           SET HPDFDOC ENCODING TO c1CPCode 
                        
                           nLineRow += nLineSpc
                        
                           @ nLineRow-7, nLineCol + 12 HPDFPRINT c1CPCode + c1CPName   FONT "Helvetica" SIZE 10
                           @ nLineRow,   nLineCol + 12 HPDFPRINT cSamplStr             FONT cFontName   SIZE nFontSize
                           @ nLineRow+7, nLineCol + 12 HPDFPRINT c1CPSmpS              FONT cFontName   SIZE nFontSize
                           
                        ELSE
                        
                           MsgStop( "Couldn't set Font Name & Size !", "ERROR ! " )
                           
                        ENDIF
                        
                     NEXT a1CPCode 
            
                  ELSE
                  
                     MsgStop( "EMPTY (internal) Font Name", "ERROR ! " )
                     
                  ENDIF
               ELSE
                  MsgStop( "TTF file " + cTTFFName + " not found !", "ERROR ! " )
               ENDIF   
            
            END HPDFPAGE  // TrueType Fonts samples
         
         NEXT // FOR EACH c1TTFFName IN aTTFFList

      END HPDFDOC
      
      IF HB_FileExists( cPdfFName )      
         Disp_PDF( cPdfFName )
      ELSE
         MsgStop( "Couldn't FOUND " + cPdfFName, "ERROR !" )
      ENDIF
      
   ELSE
      MsgStop( "Couldn't START " + cPdfFName, "ERROR !" )
   ENDIF lSuccess
   
RETURN // BuildPDF()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

